/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @file GCClient_AttributeFlags_.hpp
/// Data storage class.
///
/// This file was generated by application DATATOOL
/// using the following specifications:
/// 'gencoll_client.asn'.
///
/// ATTENTION:
///   Don't edit or commit this file into CVS as this file will
///   be overridden (by DATATOOL) without warning!

#ifndef OBJECTS_GENOMECOLL_GCCLIENT_ATTRIBUTEFLAGS_BASE_HPP
#define OBJECTS_GENOMECOLL_GCCLIENT_ATTRIBUTEFLAGS_BASE_HPP

// standard includes
#include <serial/serialbase.hpp>
BEGIN_NCBI_SCOPE

#ifndef BEGIN_objects_SCOPE
#  define BEGIN_objects_SCOPE BEGIN_SCOPE(objects)
#  define END_objects_SCOPE END_SCOPE(objects)
#endif
BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

/// This is a bitfield.  All values are powers of two.
enum EGCClient_AttributeFlags {
    eGCClient_AttributeFlags_none                          =     0,
    eGCClient_AttributeFlags_biosource                     =     1,
    eGCClient_AttributeFlags_molinfo                       =     2,  ///< obsolete; do not use
    eGCClient_AttributeFlags_all                           =     3,
    eGCClient_AttributeFlags_publications                  =     4,  ///< obsolete; do not use
    eGCClient_AttributeFlags_only_stats                    =    32,  ///< assembly level flag. Only statistics will be retrieved. For use by editing GUI.  1<<5
    eGCClient_AttributeFlags_exclude_stats                 =   512,  ///< No stats info will be retrieved.  1<<9
    eGCClient_AttributeFlags_include_unordered_scaffolds   =  1024,  ///< scaffold-flags:  by default, pseudo-scaffolds are reported as submitted.  include_unordered_scaffolds: show pseudo-scaffolds as unordered/unplaced  include_UCSC_pseudo_scaffolds: all unordered/unplaced aer shown as placed   (using UCSC coordinates of chr*_random or chrUn)   1<<10
    eGCClient_AttributeFlags_include_UCSC_pseudo_scaffolds =  2048,  ///< 1<<11
    eGCClient_AttributeFlags_exclude_aligndb               =  8192,  ///< chromosome-flags:  by default, alt-loci/patches position on chromosome reported using AlignDb  database alignments.  exclude_aligndb: report alt-loci/patches position on chromosome  using placement and not using AlignDb alignments  1<<13
    eGCClient_AttributeFlags_only_gui_data                 = 16384,  ///< Only data needed by the Assemblies GUI will be retrieved.   subsumes obsolete flags exclude_primary_assembly_scaffolds and only_gui_stats   and excludes alignment retrieval like flag exclude_aligndb.  1<<14
    eGCClient_AttributeFlags_get_wgs_contigs               = 32768  ///< If no scaffolds retrieve all wgs contigs.  1<<15
};

/// Access to EGCClient_AttributeFlags's attributes (values, names) as defined in spec
 const NCBI_NS_NCBI::CEnumeratedTypeValues* ENUM_METHOD_NAME(EGCClient_AttributeFlags)(void);


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE


#endif // OBJECTS_GENOMECOLL_GCCLIENT_ATTRIBUTEFLAGS_BASE_HPP
