/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'gbproj.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/gbproj/LoaderDescriptor.hpp>
#include <objects/general/User_object.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CLoaderDescriptor_Base::ResetLabel(void)
{
    m_Label.erase();
    m_set_State[0] &= ~0x3;
}

void CLoaderDescriptor_Base::ResetLoader_type(void)
{
    m_Loader_type.erase();
    m_set_State[0] &= ~0xc;
}

void CLoaderDescriptor_Base::ResetData(void)
{
    if ( !m_Data ) {
        m_Data.Reset(new TData());
        return;
    }
    (*m_Data).Reset();
}

void CLoaderDescriptor_Base::SetData(CLoaderDescriptor_Base::TData& value)
{
    m_Data.Reset(&value);
}

void CLoaderDescriptor_Base::Reset(void)
{
    ResetLabel();
    ResetLoader_type();
    ResetData();
    ResetEnabled();
    ResetPriority();
}

BEGIN_NAMED_BASE_CLASS_INFO("LoaderDescriptor", CLoaderDescriptor)
{
    SET_CLASS_MODULE("NCBI-GBProject");
    ADD_NAMED_STD_MEMBER("label", m_Label)->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    ADD_NAMED_STD_MEMBER("loader-type", m_Loader_type)->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    ADD_NAMED_REF_MEMBER("data", m_Data, CUser_object);
    ADD_NAMED_STD_MEMBER("enabled", m_Enabled)->SetDefault(new TEnabled(true))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_STD_MEMBER("priority", m_Priority)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CLoaderDescriptor_Base::CLoaderDescriptor_Base(void)
    : m_Enabled(true), m_Priority(0)
{
    memset(m_set_State,0,sizeof(m_set_State));
    if ( !IsAllocatedInPool() ) {
        ResetData();
    }
}

// destructor
CLoaderDescriptor_Base::~CLoaderDescriptor_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

