/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'gbproj.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/gbproj/ViewDataLink.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CViewDataLink_Base::C_Fingerprint::Reset(void)
{
    if ( m_choice != e_not_set )
        ResetSelection();
}

void CViewDataLink_Base::C_Fingerprint::ResetSelection(void)
{
    switch ( m_choice ) {
    case e_Md5:
        m_Md5.Destruct();
        break;
    default:
        break;
    }
    m_choice = e_not_set;
}

void CViewDataLink_Base::C_Fingerprint::DoSelect(E_Choice index, NCBI_NS_NCBI::CObjectMemoryPool* )
{
    switch ( index ) {
    case e_Crc32:
        m_Crc32 = 0;
        break;
    case e_Md5:
        m_Md5.Construct();
        break;
    default:
        break;
    }
    m_choice = index;
}

const char* const CViewDataLink_Base::C_Fingerprint::sm_SelectionNames[] = {
    "not set",
    "crc32",
    "md5"
};

NCBI_NS_STD::string CViewDataLink_Base::C_Fingerprint::SelectionName(E_Choice index)
{
    return NCBI_NS_NCBI::CInvalidChoiceSelection::GetName(index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

void CViewDataLink_Base::C_Fingerprint::ThrowInvalidSelection(E_Choice index) const
{
    throw NCBI_NS_NCBI::CInvalidChoiceSelection(DIAG_COMPILE_INFO, this, m_choice, index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

// helper methods

// type info
BEGIN_NAMED_CHOICE_INFO("", CViewDataLink_Base::C_Fingerprint)
{
    SET_INTERNAL_NAME("ViewDataLink", "fingerprint");
    SET_CHOICE_MODULE("NCBI-GBProject");
    ADD_NAMED_STD_CHOICE_VARIANT("crc32", m_Crc32);
    ADD_NAMED_BUF_CHOICE_VARIANT("md5", m_Md5, STL_CHAR_vector, (char));
    info->CodeVersion(21600);
}
END_CHOICE_INFO

// constructor
CViewDataLink_Base::C_Fingerprint::C_Fingerprint(void)
    : m_choice(e_not_set)
{
}

// destructor
CViewDataLink_Base::C_Fingerprint::~C_Fingerprint(void)
{
    Reset();
}


void CViewDataLink_Base::ResetFingerprint(void)
{
    m_Fingerprint.Reset();
}

void CViewDataLink_Base::SetFingerprint(CViewDataLink_Base::TFingerprint& value)
{
    m_Fingerprint.Reset(&value);
}

CViewDataLink_Base::TFingerprint& CViewDataLink_Base::SetFingerprint(void)
{
    if ( !m_Fingerprint )
        m_Fingerprint.Reset(new C_Fingerprint());
    return (*m_Fingerprint);
}

void CViewDataLink_Base::ResetType(void)
{
    m_Type.erase();
    m_set_State[0] &= ~0x30;
}

void CViewDataLink_Base::Reset(void)
{
    ResetProject_item_id();
    ResetFingerprint();
    ResetType();
}

BEGIN_NAMED_BASE_CLASS_INFO("ViewDataLink", CViewDataLink)
{
    SET_CLASS_MODULE("NCBI-GBProject");
    ADD_NAMED_STD_MEMBER("project-item-id", m_Project_item_id)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_REF_MEMBER("fingerprint", m_Fingerprint, C_Fingerprint)->SetOptional();
    ADD_NAMED_STD_MEMBER("type", m_Type)->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CViewDataLink_Base::CViewDataLink_Base(void)
    : m_Project_item_id(0)
{
    memset(m_set_State,0,sizeof(m_set_State));
}

// destructor
CViewDataLink_Base::~CViewDataLink_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

