/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'gencoll_client.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/genomecoll/GCClientRequest.hpp>
#include <objects/genomecoll/GCClient_FindBestAssemblyR.hpp>
#include <objects/genomecoll/GCClient_GetAssemblyBlobRe.hpp>
#include <objects/genomecoll/GCClient_GetAssemblyBySequ.hpp>
#include <objects/genomecoll/GCClient_GetAssemblyReques.hpp>
#include <objects/genomecoll/GCClient_GetEquivalentAsse.hpp>
#include <objects/genomecoll/GCClient_ValidateChrTypeLo.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CGCClientRequest_Base::Reset(void)
{
    if ( m_choice != e_not_set )
        ResetSelection();
}

void CGCClientRequest_Base::ResetSelection(void)
{
    switch ( m_choice ) {
    case e_Get_assembly:
    case e_Get_chrtype_valid:
    case e_Get_best_assembly:
    case e_Get_equivalent_assemblies:
    case e_Get_assembly_blob:
    case e_Get_assembly_by_sequence:
        m_object->RemoveReference();
        break;
    default:
        break;
    }
    m_choice = e_not_set;
}

void CGCClientRequest_Base::DoSelect(E_Choice index, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    switch ( index ) {
    case e_Get_assembly:
        (m_object = new(pool) ncbi::objects::CGCClient_GetAssemblyRequest())->AddReference();
        break;
    case e_Get_chrtype_valid:
        (m_object = new(pool) ncbi::objects::CGCClient_ValidateChrTypeLocRequest())->AddReference();
        break;
    case e_Get_best_assembly:
        (m_object = new(pool) ncbi::objects::CGCClient_FindBestAssemblyRequest())->AddReference();
        break;
    case e_Get_equivalent_assemblies:
        (m_object = new(pool) ncbi::objects::CGCClient_GetEquivalentAssembliesRequest())->AddReference();
        break;
    case e_Get_assembly_blob:
        (m_object = new(pool) ncbi::objects::CGCClient_GetAssemblyBlobRequest())->AddReference();
        break;
    case e_Get_assembly_by_sequence:
        (m_object = new(pool) ncbi::objects::CGCClient_GetAssemblyBySequenceRequest())->AddReference();
        break;
    default:
        break;
    }
    m_choice = index;
}

const char* const CGCClientRequest_Base::sm_SelectionNames[] = {
    "not set",
    "get-assembly",
    "get-chrtype-valid",
    "get-best-assembly",
    "get-equivalent-assemblies",
    "get-assembly-blob",
    "get-assembly-by-sequence"
};

NCBI_NS_STD::string CGCClientRequest_Base::SelectionName(E_Choice index)
{
    return NCBI_NS_NCBI::CInvalidChoiceSelection::GetName(index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

void CGCClientRequest_Base::ThrowInvalidSelection(E_Choice index) const
{
    throw NCBI_NS_NCBI::CInvalidChoiceSelection(DIAG_COMPILE_INFO, this, m_choice, index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

const CGCClientRequest_Base::TGet_assembly& CGCClientRequest_Base::GetGet_assembly(void) const
{
    CheckSelected(e_Get_assembly);
    return *static_cast<const TGet_assembly*>(m_object);
}

CGCClientRequest_Base::TGet_assembly& CGCClientRequest_Base::SetGet_assembly(void)
{
    Select(e_Get_assembly, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TGet_assembly*>(m_object);
}

void CGCClientRequest_Base::SetGet_assembly(CGCClientRequest_Base::TGet_assembly& value)
{
    TGet_assembly* ptr = &value;
    if ( m_choice != e_Get_assembly || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Get_assembly;
    }
}

const CGCClientRequest_Base::TGet_chrtype_valid& CGCClientRequest_Base::GetGet_chrtype_valid(void) const
{
    CheckSelected(e_Get_chrtype_valid);
    return *static_cast<const TGet_chrtype_valid*>(m_object);
}

CGCClientRequest_Base::TGet_chrtype_valid& CGCClientRequest_Base::SetGet_chrtype_valid(void)
{
    Select(e_Get_chrtype_valid, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TGet_chrtype_valid*>(m_object);
}

void CGCClientRequest_Base::SetGet_chrtype_valid(CGCClientRequest_Base::TGet_chrtype_valid& value)
{
    TGet_chrtype_valid* ptr = &value;
    if ( m_choice != e_Get_chrtype_valid || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Get_chrtype_valid;
    }
}

const CGCClientRequest_Base::TGet_best_assembly& CGCClientRequest_Base::GetGet_best_assembly(void) const
{
    CheckSelected(e_Get_best_assembly);
    return *static_cast<const TGet_best_assembly*>(m_object);
}

CGCClientRequest_Base::TGet_best_assembly& CGCClientRequest_Base::SetGet_best_assembly(void)
{
    Select(e_Get_best_assembly, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TGet_best_assembly*>(m_object);
}

void CGCClientRequest_Base::SetGet_best_assembly(CGCClientRequest_Base::TGet_best_assembly& value)
{
    TGet_best_assembly* ptr = &value;
    if ( m_choice != e_Get_best_assembly || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Get_best_assembly;
    }
}

const CGCClientRequest_Base::TGet_equivalent_assemblies& CGCClientRequest_Base::GetGet_equivalent_assemblies(void) const
{
    CheckSelected(e_Get_equivalent_assemblies);
    return *static_cast<const TGet_equivalent_assemblies*>(m_object);
}

CGCClientRequest_Base::TGet_equivalent_assemblies& CGCClientRequest_Base::SetGet_equivalent_assemblies(void)
{
    Select(e_Get_equivalent_assemblies, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TGet_equivalent_assemblies*>(m_object);
}

void CGCClientRequest_Base::SetGet_equivalent_assemblies(CGCClientRequest_Base::TGet_equivalent_assemblies& value)
{
    TGet_equivalent_assemblies* ptr = &value;
    if ( m_choice != e_Get_equivalent_assemblies || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Get_equivalent_assemblies;
    }
}

const CGCClientRequest_Base::TGet_assembly_blob& CGCClientRequest_Base::GetGet_assembly_blob(void) const
{
    CheckSelected(e_Get_assembly_blob);
    return *static_cast<const TGet_assembly_blob*>(m_object);
}

CGCClientRequest_Base::TGet_assembly_blob& CGCClientRequest_Base::SetGet_assembly_blob(void)
{
    Select(e_Get_assembly_blob, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TGet_assembly_blob*>(m_object);
}

void CGCClientRequest_Base::SetGet_assembly_blob(CGCClientRequest_Base::TGet_assembly_blob& value)
{
    TGet_assembly_blob* ptr = &value;
    if ( m_choice != e_Get_assembly_blob || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Get_assembly_blob;
    }
}

const CGCClientRequest_Base::TGet_assembly_by_sequence& CGCClientRequest_Base::GetGet_assembly_by_sequence(void) const
{
    CheckSelected(e_Get_assembly_by_sequence);
    return *static_cast<const TGet_assembly_by_sequence*>(m_object);
}

CGCClientRequest_Base::TGet_assembly_by_sequence& CGCClientRequest_Base::SetGet_assembly_by_sequence(void)
{
    Select(e_Get_assembly_by_sequence, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TGet_assembly_by_sequence*>(m_object);
}

void CGCClientRequest_Base::SetGet_assembly_by_sequence(CGCClientRequest_Base::TGet_assembly_by_sequence& value)
{
    TGet_assembly_by_sequence* ptr = &value;
    if ( m_choice != e_Get_assembly_by_sequence || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Get_assembly_by_sequence;
    }
}

// helper methods

// type info
BEGIN_NAMED_BASE_CHOICE_INFO("GCClientRequest", CGCClientRequest)
{
    SET_CHOICE_MODULE("NCBI-GencollClient");
    ADD_NAMED_REF_CHOICE_VARIANT("get-assembly", m_object, CGCClient_GetAssemblyRequest);
    ADD_NAMED_REF_CHOICE_VARIANT("get-chrtype-valid", m_object, CGCClient_ValidateChrTypeLocRequest);
    ADD_NAMED_REF_CHOICE_VARIANT("get-best-assembly", m_object, CGCClient_FindBestAssemblyRequest);
    ADD_NAMED_REF_CHOICE_VARIANT("get-equivalent-assemblies", m_object, CGCClient_GetEquivalentAssembliesRequest);
    ADD_NAMED_REF_CHOICE_VARIANT("get-assembly-blob", m_object, CGCClient_GetAssemblyBlobRequest);
    ADD_NAMED_REF_CHOICE_VARIANT("get-assembly-by-sequence", m_object, CGCClient_GetAssemblyBySequenceRequest);
    info->CodeVersion(21600);
}
END_CHOICE_INFO

// constructor
CGCClientRequest_Base::CGCClientRequest_Base(void)
    : m_choice(e_not_set)
{
}

// destructor
CGCClientRequest_Base::~CGCClientRequest_Base(void)
{
    Reset();
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

