/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'gencoll_client.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/genomecoll/GCClient_AssemblySequenceI.hpp>
#include <objects/genomecoll/GCClient_AssemblyInfo.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CGCClient_AssemblySequenceInfo_Base::ResetAssembly(void)
{
    if ( !m_Assembly ) {
        m_Assembly.Reset(new TAssembly());
        return;
    }
    (*m_Assembly).Reset();
}

void CGCClient_AssemblySequenceInfo_Base::SetAssembly(CGCClient_AssemblySequenceInfo_Base::TAssembly& value)
{
    m_Assembly.Reset(&value);
}

void CGCClient_AssemblySequenceInfo_Base::ResetSequences_in_assembly(void)
{
    m_Sequences_in_assembly.clear();
    m_set_State[0] &= ~0xc;
}

void CGCClient_AssemblySequenceInfo_Base::ResetSequences_not_in_assembly(void)
{
    m_Sequences_not_in_assembly.clear();
    m_set_State[0] &= ~0x30;
}

void CGCClient_AssemblySequenceInfo_Base::Reset(void)
{
    ResetAssembly();
    ResetSequences_in_assembly();
    ResetSequences_not_in_assembly();
}

BEGIN_NAMED_BASE_CLASS_INFO("GCClient-AssemblySequenceInfo", CGCClient_AssemblySequenceInfo)
{
    SET_CLASS_MODULE("NCBI-GencollClient");
    ADD_NAMED_REF_MEMBER("assembly", m_Assembly, CGCClient_AssemblyInfo);
    ADD_NAMED_MEMBER("sequences-in-assembly", m_Sequences_in_assembly, STL_list_set, (STD, (string)))->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    ADD_NAMED_MEMBER("sequences-not-in-assembly", m_Sequences_not_in_assembly, STL_list_set, (STD, (string)))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CGCClient_AssemblySequenceInfo_Base::CGCClient_AssemblySequenceInfo_Base(void)
{
    memset(m_set_State,0,sizeof(m_set_State));
    if ( !IsAllocatedInPool() ) {
        ResetAssembly();
    }
}

// destructor
CGCClient_AssemblySequenceInfo_Base::~CGCClient_AssemblySequenceInfo_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

