/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'gencoll_client.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/genomecoll/GCClient_FindBestAssemblyR.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CGCClient_FindBestAssemblyRequest_Base::ResetSeq_id_acc(void)
{
    m_Seq_id_acc.clear();
    m_set_State[0] &= ~0x3;
}

void CGCClient_FindBestAssemblyRequest_Base::Reset(void)
{
    ResetSeq_id_acc();
    ResetFilter();
    ResetSort();
    ResetAssembly_return_limit();
}

BEGIN_NAMED_BASE_CLASS_INFO("GCClient-FindBestAssemblyRequest", CGCClient_FindBestAssemblyRequest)
{
    SET_CLASS_MODULE("NCBI-GencollClient");
    ADD_NAMED_MEMBER("seq-id-acc", m_Seq_id_acc, STL_list_set, (STD, (string)))->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    ADD_NAMED_ENUM_MEMBER("filter", m_Filter, EGCClient_FindBestAssemblyFilter)->SetDefault(new TFilter(eGCClient_FindBestAssemblyFilter_latest_major_annotated))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_ENUM_MEMBER("sort", m_Sort, EGCClient_FindBestAssemblySort)->SetDefault(new TSort(eGCClient_FindBestAssemblySort_default))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_STD_MEMBER("assembly-return-limit", m_Assembly_return_limit)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CGCClient_FindBestAssemblyRequest_Base::CGCClient_FindBestAssemblyRequest_Base(void)
    : m_Filter(eGCClient_FindBestAssemblyFilter_latest_major_annotated), m_Sort(eGCClient_FindBestAssemblySort_default), m_Assembly_return_limit(0)
{
    memset(m_set_State,0,sizeof(m_set_State));
}

// destructor
CGCClient_FindBestAssemblyRequest_Base::~CGCClient_FindBestAssemblyRequest_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

