/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'gencoll_client.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/genomecoll/GCClient_GetAssemblyBySequ.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

BEGIN_NAMED_ENUM_IN_INFO("", CGCClient_GetAssemblyBySequenceRequest_Base::, ESort, true)
{
    SET_ENUM_INTERNAL_NAME("GCClient-GetAssemblyBySequenceRequest", "sort");
    SET_ENUM_MODULE("NCBI-GencollClient");
    ADD_ENUM_VALUE("default", eSort_default);
    ADD_ENUM_VALUE("latest", eSort_latest);
    ADD_ENUM_VALUE("major", eSort_major);
}
END_ENUM_INFO

void CGCClient_GetAssemblyBySequenceRequest_Base::ResetSequence_acc(void)
{
    m_Sequence_acc.clear();
    m_set_State[0] &= ~0x3;
}

void CGCClient_GetAssemblyBySequenceRequest_Base::Reset(void)
{
    ResetSequence_acc();
    ResetFilter();
    ResetSort();
    ResetTop_assembly_only();
}

BEGIN_NAMED_BASE_CLASS_INFO("GCClient-GetAssemblyBySequenceRequest", CGCClient_GetAssemblyBySequenceRequest)
{
    SET_CLASS_MODULE("NCBI-GencollClient");
    ADD_NAMED_MEMBER("sequence-acc", m_Sequence_acc, STL_list_set, (STD, (string)))->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    ADD_NAMED_ENUM_MEMBER("filter", m_Filter, EGCClient_GetAssemblyBySequenceFilter)->SetDefault(new TFilter(eGCClient_GetAssemblyBySequenceFilter_all))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_ENUM_MEMBER("sort", m_Sort, ESort)->SetDefault(new TSort(eSort_default))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_STD_MEMBER("top-assembly-only", m_Top_assembly_only)->SetDefault(new TTop_assembly_only(0))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CGCClient_GetAssemblyBySequenceRequest_Base::CGCClient_GetAssemblyBySequenceRequest_Base(void)
    : m_Filter(eGCClient_GetAssemblyBySequenceFilter_all), m_Sort(eSort_default), m_Top_assembly_only(0)
{
    memset(m_set_State,0,sizeof(m_set_State));
}

// destructor
CGCClient_GetAssemblyBySequenceRequest_Base::~CGCClient_GetAssemblyBySequenceRequest_Base(void)
{
}


BEGIN_NAMED_ENUM_INFO("GCClient-GetAssemblyBySequenceFilter", EGCClient_GetAssemblyBySequenceFilter, true)
{
    SET_ENUM_MODULE("NCBI-GencollClient");
    ADD_ENUM_VALUE("all", eGCClient_GetAssemblyBySequenceFilter_all);
    ADD_ENUM_VALUE("latest", eGCClient_GetAssemblyBySequenceFilter_latest);
    ADD_ENUM_VALUE("major", eGCClient_GetAssemblyBySequenceFilter_major);
    ADD_ENUM_VALUE("genbank", eGCClient_GetAssemblyBySequenceFilter_genbank);
    ADD_ENUM_VALUE("refseq", eGCClient_GetAssemblyBySequenceFilter_refseq);
}
END_ENUM_INFO


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

