/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'trackmgr.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/trackmgr/TMgr_AssemblySpec.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CTMgr_AssemblySpec_Base::C_Name::ResetName(void)
{
    m_Name.erase();
    m_set_State[0] &= ~0xc;
}

void CTMgr_AssemblySpec_Base::C_Name::Reset(void)
{
    ResetTax_id();
    ResetName();
}

BEGIN_NAMED_CLASS_INFO("", CTMgr_AssemblySpec_Base::C_Name)
{
    SET_INTERNAL_NAME("TMgr-AssemblySpec", "name");
    SET_CLASS_MODULE("NCBI-TrackManager");
    ADD_NAMED_STD_MEMBER("tax-id", m_Tax_id)->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    ADD_NAMED_STD_MEMBER("name", m_Name)->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CTMgr_AssemblySpec_Base::C_Name::C_Name(void)
    : m_Tax_id(0)
{
    memset(m_set_State,0,sizeof(m_set_State));
}

// destructor
CTMgr_AssemblySpec_Base::C_Name::~C_Name(void)
{
}


void CTMgr_AssemblySpec_Base::Reset(void)
{
    if ( m_choice != e_not_set )
        ResetSelection();
}

void CTMgr_AssemblySpec_Base::ResetSelection(void)
{
    switch ( m_choice ) {
    case e_Accession:
        m_string.Destruct();
        break;
    case e_Name:
        m_object->RemoveReference();
        break;
    default:
        break;
    }
    m_choice = e_not_set;
}

void CTMgr_AssemblySpec_Base::DoSelect(E_Choice index, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    switch ( index ) {
    case e_Name:
        (m_object = new(pool) C_Name())->AddReference();
        break;
    case e_Accession:
        m_string.Construct();
        break;
    default:
        break;
    }
    m_choice = index;
}

const char* const CTMgr_AssemblySpec_Base::sm_SelectionNames[] = {
    "not set",
    "name",
    "accession",
    "all-assemblies"
};

NCBI_NS_STD::string CTMgr_AssemblySpec_Base::SelectionName(E_Choice index)
{
    return NCBI_NS_NCBI::CInvalidChoiceSelection::GetName(index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

void CTMgr_AssemblySpec_Base::ThrowInvalidSelection(E_Choice index) const
{
    throw NCBI_NS_NCBI::CInvalidChoiceSelection(DIAG_COMPILE_INFO, this, m_choice, index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

const CTMgr_AssemblySpec_Base::TName& CTMgr_AssemblySpec_Base::GetName(void) const
{
    CheckSelected(e_Name);
    return *static_cast<const TName*>(m_object);
}

CTMgr_AssemblySpec_Base::TName& CTMgr_AssemblySpec_Base::SetName(void)
{
    Select(e_Name, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TName*>(m_object);
}

void CTMgr_AssemblySpec_Base::SetName(CTMgr_AssemblySpec_Base::TName& value)
{
    TName* ptr = &value;
    if ( m_choice != e_Name || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Name;
    }
}

void CTMgr_AssemblySpec_Base::SetAccession(const CTMgr_AssemblySpec_Base::TAccession& value)
{
    Select(e_Accession, NCBI_NS_NCBI::eDoNotResetVariant);
    *m_string = value;
}

// helper methods

// type info
BEGIN_NAMED_BASE_CHOICE_INFO("TMgr-AssemblySpec", CTMgr_AssemblySpec)
{
    SET_CHOICE_MODULE("NCBI-TrackManager");
    ADD_NAMED_REF_CHOICE_VARIANT("name", m_object, C_Name);
    ADD_NAMED_BUF_CHOICE_VARIANT("accession", m_string, STD, (string));
    ADD_NAMED_NULL_CHOICE_VARIANT("all-assemblies", null, ());
    info->CodeVersion(21600);
}
END_CHOICE_INFO

// constructor
CTMgr_AssemblySpec_Base::CTMgr_AssemblySpec_Base(void)
    : m_choice(e_not_set)
{
}

// destructor
CTMgr_AssemblySpec_Base::~CTMgr_AssemblySpec_Base(void)
{
    Reset();
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

