/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'trackmgr.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/trackmgr/TMgr_ClientInfo.hpp>
#include <objects/trackmgr/TMgr_AttrSpec.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CTMgr_ClientInfo_Base::ResetClient_name(void)
{
    m_Client_name.erase();
    m_set_State[0] &= ~0x3;
}

void CTMgr_ClientInfo_Base::ResetContext(void)
{
    m_Context.erase();
    m_set_State[0] &= ~0xc;
}

void CTMgr_ClientInfo_Base::ResetContext_attrs(void)
{
    m_Context_attrs.clear();
    m_set_State[0] &= ~0xc0;
}

void CTMgr_ClientInfo_Base::Reset(void)
{
    ResetClient_name();
    ResetContext();
    ResetInhouse();
    ResetContext_attrs();
}

BEGIN_NAMED_BASE_CLASS_INFO("TMgr-ClientInfo", CTMgr_ClientInfo)
{
    SET_CLASS_MODULE("NCBI-TrackManager");
    ADD_NAMED_STD_MEMBER("client-name", m_Client_name)->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    ADD_NAMED_STD_MEMBER("context", m_Context)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_STD_MEMBER("inhouse", m_Inhouse)->SetDefault(new TInhouse(false))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_MEMBER("context-attrs", m_Context_attrs, STL_list_set, (STL_CRef, (CLASS, (CTMgr_AttrSpec))))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CTMgr_ClientInfo_Base::CTMgr_ClientInfo_Base(void)
    : m_Inhouse(false)
{
    memset(m_set_State,0,sizeof(m_set_State));
}

// destructor
CTMgr_ClientInfo_Base::~CTMgr_ClientInfo_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

