/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'trackmgr.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/trackmgr/TMgr_CreateTracksetRequest.hpp>
#include <objects/trackmgr/TMgr_DTrackId.hpp>
#include <objects/trackmgr/TMgr_GenomeContext.hpp>
#include <objects/trackmgr/TMgr_Identity.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CTMgr_CreateTracksetRequest_Base::ResetIdentity(void)
{
    m_Identity.Reset();
}

void CTMgr_CreateTracksetRequest_Base::SetIdentity(CTMgr_CreateTracksetRequest_Base::TIdentity& value)
{
    m_Identity.Reset(&value);
}

CTMgr_CreateTracksetRequest_Base::TIdentity& CTMgr_CreateTracksetRequest_Base::SetIdentity(void)
{
    if ( !m_Identity )
        m_Identity.Reset(new ncbi::objects::CTMgr_Identity());
    return (*m_Identity);
}

void CTMgr_CreateTracksetRequest_Base::ResetGenome_context(void)
{
    if ( !m_Genome_context ) {
        m_Genome_context.Reset(new TGenome_context());
        return;
    }
    (*m_Genome_context).Reset();
}

void CTMgr_CreateTracksetRequest_Base::SetGenome_context(CTMgr_CreateTracksetRequest_Base::TGenome_context& value)
{
    m_Genome_context.Reset(&value);
}

void CTMgr_CreateTracksetRequest_Base::ResetName(void)
{
    m_Name.erase();
    m_set_State[0] &= ~0x30;
}

void CTMgr_CreateTracksetRequest_Base::ResetDescription(void)
{
    m_Description.erase();
    m_set_State[0] &= ~0xc0;
}

void CTMgr_CreateTracksetRequest_Base::ResetTracks(void)
{
    m_Tracks.clear();
    m_set_State[0] &= ~0x300;
}

void CTMgr_CreateTracksetRequest_Base::Reset(void)
{
    ResetIdentity();
    ResetGenome_context();
    ResetName();
    ResetDescription();
    ResetTracks();
}

BEGIN_NAMED_BASE_CLASS_INFO("TMgr-CreateTracksetRequest", CTMgr_CreateTracksetRequest)
{
    SET_CLASS_MODULE("NCBI-TrackManager");
    ADD_NAMED_REF_MEMBER("identity", m_Identity, CTMgr_Identity)->SetOptional();
    ADD_NAMED_REF_MEMBER("genome-context", m_Genome_context, CTMgr_GenomeContext);
    ADD_NAMED_MEMBER("name", m_Name, CStringUTF8, ())->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    ADD_NAMED_MEMBER("description", m_Description, CStringUTF8, ())->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_MEMBER("tracks", m_Tracks, STL_list, (STL_CRef, (CLASS, (CTMgr_DTrackId))))->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CTMgr_CreateTracksetRequest_Base::CTMgr_CreateTracksetRequest_Base(void)
{
    memset(m_set_State,0,sizeof(m_set_State));
    if ( !IsAllocatedInPool() ) {
        ResetGenome_context();
    }
}

// destructor
CTMgr_CreateTracksetRequest_Base::~CTMgr_CreateTracksetRequest_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

