/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'trackmgr.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/trackmgr/TMgr_DatasetItemSeq.hpp>
#include <objects/seqloc/Seq_id.hpp>
#include <objects/trackmgr/TMgr_AnnotCounts.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CTMgr_DatasetItemSeq_Base::ResetSeq_id(void)
{
    if ( !m_Seq_id ) {
        m_Seq_id.Reset(new TSeq_id());
        return;
    }
    (*m_Seq_id).Reset();
}

void CTMgr_DatasetItemSeq_Base::SetSeq_id(CTMgr_DatasetItemSeq_Base::TSeq_id& value)
{
    m_Seq_id.Reset(&value);
}

void CTMgr_DatasetItemSeq_Base::ResetCounts(void)
{
    m_Counts.Reset();
}

void CTMgr_DatasetItemSeq_Base::SetCounts(CTMgr_DatasetItemSeq_Base::TCounts& value)
{
    m_Counts.Reset(&value);
}

CTMgr_DatasetItemSeq_Base::TCounts& CTMgr_DatasetItemSeq_Base::SetCounts(void)
{
    if ( !m_Counts )
        m_Counts.Reset(new ncbi::objects::CTMgr_AnnotCounts());
    return (*m_Counts);
}

void CTMgr_DatasetItemSeq_Base::ResetSeq_id2(void)
{
    m_Seq_id2.Reset();
}

void CTMgr_DatasetItemSeq_Base::SetSeq_id2(CTMgr_DatasetItemSeq_Base::TSeq_id2& value)
{
    m_Seq_id2.Reset(&value);
}

CTMgr_DatasetItemSeq_Base::TSeq_id2& CTMgr_DatasetItemSeq_Base::SetSeq_id2(void)
{
    if ( !m_Seq_id2 )
        m_Seq_id2.Reset(new ncbi::objects::CSeq_id());
    return (*m_Seq_id2);
}

void CTMgr_DatasetItemSeq_Base::Reset(void)
{
    ResetSeq_id();
    ResetCounts();
    ResetSeq_id2();
}

BEGIN_NAMED_BASE_CLASS_INFO("TMgr-DatasetItemSeq", CTMgr_DatasetItemSeq)
{
    SET_CLASS_MODULE("NCBI-TrackManager");
    ADD_NAMED_REF_MEMBER("seq-id", m_Seq_id, CSeq_id);
    ADD_NAMED_REF_MEMBER("counts", m_Counts, CTMgr_AnnotCounts)->SetOptional();
    ADD_NAMED_REF_MEMBER("seq-id2", m_Seq_id2, CSeq_id)->SetOptional();
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CTMgr_DatasetItemSeq_Base::CTMgr_DatasetItemSeq_Base(void)
{
    memset(m_set_State,0,sizeof(m_set_State));
    if ( !IsAllocatedInPool() ) {
        ResetSeq_id();
    }
}

// destructor
CTMgr_DatasetItemSeq_Base::~CTMgr_DatasetItemSeq_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

