/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'trackmgr.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/trackmgr/TMgr_GenomeContext.hpp>
#include <objects/seqloc/Seq_id.hpp>
#include <objects/trackmgr/TMgr_AssemblySpec.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CTMgr_GenomeContext_Base::Reset(void)
{
    if ( m_choice != e_not_set )
        ResetSelection();
}

void CTMgr_GenomeContext_Base::ResetSelection(void)
{
    switch ( m_choice ) {
    case e_Assembly:
    case e_Sequence:
        m_object->RemoveReference();
        break;
    default:
        break;
    }
    m_choice = e_not_set;
}

void CTMgr_GenomeContext_Base::DoSelect(E_Choice index, NCBI_NS_NCBI::CObjectMemoryPool* pool)
{
    switch ( index ) {
    case e_Assembly:
        (m_object = new(pool) ncbi::objects::CTMgr_AssemblySpec())->AddReference();
        break;
    case e_Sequence:
        (m_object = new(pool) ncbi::objects::CSeq_id())->AddReference();
        break;
    default:
        break;
    }
    m_choice = index;
}

const char* const CTMgr_GenomeContext_Base::sm_SelectionNames[] = {
    "not set",
    "assembly",
    "sequence",
    "refseqgene",
    "all"
};

NCBI_NS_STD::string CTMgr_GenomeContext_Base::SelectionName(E_Choice index)
{
    return NCBI_NS_NCBI::CInvalidChoiceSelection::GetName(index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

void CTMgr_GenomeContext_Base::ThrowInvalidSelection(E_Choice index) const
{
    throw NCBI_NS_NCBI::CInvalidChoiceSelection(DIAG_COMPILE_INFO, this, m_choice, index, sm_SelectionNames, sizeof(sm_SelectionNames)/sizeof(sm_SelectionNames[0]));
}

const CTMgr_GenomeContext_Base::TAssembly& CTMgr_GenomeContext_Base::GetAssembly(void) const
{
    CheckSelected(e_Assembly);
    return *static_cast<const TAssembly*>(m_object);
}

CTMgr_GenomeContext_Base::TAssembly& CTMgr_GenomeContext_Base::SetAssembly(void)
{
    Select(e_Assembly, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TAssembly*>(m_object);
}

void CTMgr_GenomeContext_Base::SetAssembly(CTMgr_GenomeContext_Base::TAssembly& value)
{
    TAssembly* ptr = &value;
    if ( m_choice != e_Assembly || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Assembly;
    }
}

const CTMgr_GenomeContext_Base::TSequence& CTMgr_GenomeContext_Base::GetSequence(void) const
{
    CheckSelected(e_Sequence);
    return *static_cast<const TSequence*>(m_object);
}

CTMgr_GenomeContext_Base::TSequence& CTMgr_GenomeContext_Base::SetSequence(void)
{
    Select(e_Sequence, NCBI_NS_NCBI::eDoNotResetVariant);
    return *static_cast<TSequence*>(m_object);
}

void CTMgr_GenomeContext_Base::SetSequence(CTMgr_GenomeContext_Base::TSequence& value)
{
    TSequence* ptr = &value;
    if ( m_choice != e_Sequence || m_object != ptr ) {
        ResetSelection();
        (m_object = ptr)->AddReference();
        m_choice = e_Sequence;
    }
}

// helper methods

// type info
BEGIN_NAMED_BASE_CHOICE_INFO("TMgr-GenomeContext", CTMgr_GenomeContext)
{
    SET_CHOICE_MODULE("NCBI-TrackManager");
    ADD_NAMED_REF_CHOICE_VARIANT("assembly", m_object, CTMgr_AssemblySpec);
    ADD_NAMED_REF_CHOICE_VARIANT("sequence", m_object, CSeq_id);
    ADD_NAMED_NULL_CHOICE_VARIANT("refseqgene", null, ());
    ADD_NAMED_NULL_CHOICE_VARIANT("all", null, ());
    info->CodeVersion(21600);
}
END_CHOICE_INFO

// constructor
CTMgr_GenomeContext_Base::CTMgr_GenomeContext_Base(void)
    : m_choice(e_not_set)
{
}

// destructor
CTMgr_GenomeContext_Base::~CTMgr_GenomeContext_Base(void)
{
    Reset();
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

