/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'trackmgr.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/trackmgr/TMgr_RemoveUserTrackReques.hpp>
#include <objects/trackmgr/TMgr_DTrackId.hpp>
#include <objects/trackmgr/TMgr_Identity.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CTMgr_RemoveUserTrackRequest_Base::ResetIdentity(void)
{
    if ( !m_Identity ) {
        m_Identity.Reset(new TIdentity());
        return;
    }
    (*m_Identity).Reset();
}

void CTMgr_RemoveUserTrackRequest_Base::SetIdentity(CTMgr_RemoveUserTrackRequest_Base::TIdentity& value)
{
    m_Identity.Reset(&value);
}

void CTMgr_RemoveUserTrackRequest_Base::ResetDtrack_ids(void)
{
    m_Dtrack_ids.clear();
    m_set_State[0] &= ~0xc;
}

void CTMgr_RemoveUserTrackRequest_Base::Reset(void)
{
    ResetIdentity();
    ResetDtrack_ids();
}

BEGIN_NAMED_BASE_CLASS_INFO("TMgr-RemoveUserTrackRequest", CTMgr_RemoveUserTrackRequest)
{
    SET_CLASS_MODULE("NCBI-TrackManager");
    ADD_NAMED_REF_MEMBER("identity", m_Identity, CTMgr_Identity);
    ADD_NAMED_MEMBER("dtrack-ids", m_Dtrack_ids, STL_list_set, (STL_CRef, (CLASS, (CTMgr_DTrackId))))->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CTMgr_RemoveUserTrackRequest_Base::CTMgr_RemoveUserTrackRequest_Base(void)
{
    memset(m_set_State,0,sizeof(m_set_State));
    if ( !IsAllocatedInPool() ) {
        ResetIdentity();
    }
}

// destructor
CTMgr_RemoveUserTrackRequest_Base::~CTMgr_RemoveUserTrackRequest_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

