/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'trackmgr.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/trackmgr/TMgr_RetrieveTracksetReply.hpp>
#include <objects/trackmgr/TMgr_Message.hpp>
#include <objects/trackmgr/TMgr_TrackSet.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CTMgr_RetrieveTracksetReply_Base::C_Flags::Reset(void)
{
    ResetInclude_track_items();
}

BEGIN_NAMED_CLASS_INFO("", CTMgr_RetrieveTracksetReply_Base::C_Flags)
{
    SET_INTERNAL_NAME("TMgr-RetrieveTracksetReply", "flags");
    SET_CLASS_MODULE("NCBI-TrackManager");
    ADD_NAMED_STD_MEMBER("include-track-items", m_Include_track_items)->SetDefault(new TInclude_track_items(false))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CTMgr_RetrieveTracksetReply_Base::C_Flags::C_Flags(void)
    : m_Include_track_items(false)
{
    memset(m_set_State,0,sizeof(m_set_State));
}

// destructor
CTMgr_RetrieveTracksetReply_Base::C_Flags::~C_Flags(void)
{
}


void CTMgr_RetrieveTracksetReply_Base::ResetMessages(void)
{
    m_Messages.clear();
    m_set_State[0] &= ~0x3;
}

void CTMgr_RetrieveTracksetReply_Base::ResetTracksets(void)
{
    m_Tracksets.clear();
    m_set_State[0] &= ~0xc;
}

void CTMgr_RetrieveTracksetReply_Base::ResetFlags(void)
{
    m_Flags.Reset();
}

void CTMgr_RetrieveTracksetReply_Base::SetFlags(CTMgr_RetrieveTracksetReply_Base::TFlags& value)
{
    m_Flags.Reset(&value);
}

CTMgr_RetrieveTracksetReply_Base::TFlags& CTMgr_RetrieveTracksetReply_Base::SetFlags(void)
{
    if ( !m_Flags )
        m_Flags.Reset(new C_Flags());
    return (*m_Flags);
}

void CTMgr_RetrieveTracksetReply_Base::Reset(void)
{
    ResetMessages();
    ResetTracksets();
    ResetFlags();
}

BEGIN_NAMED_BASE_CLASS_INFO("TMgr-RetrieveTracksetReply", CTMgr_RetrieveTracksetReply)
{
    SET_CLASS_MODULE("NCBI-TrackManager");
    ADD_NAMED_MEMBER("messages", m_Messages, STL_list, (STL_CRef, (CLASS, (CTMgr_Message))))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_MEMBER("tracksets", m_Tracksets, STL_list_set, (STL_CRef, (CLASS, (CTMgr_TrackSet))))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_REF_MEMBER("flags", m_Flags, C_Flags)->SetOptional();
    info->RandomOrder();
    info->CodeVersion(21600);
}
END_CLASS_INFO

// constructor
CTMgr_RetrieveTracksetReply_Base::CTMgr_RetrieveTracksetReply_Base(void)
{
    memset(m_set_State,0,sizeof(m_set_State));
}

// destructor
CTMgr_RetrieveTracksetReply_Base::~CTMgr_RetrieveTracksetReply_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

