/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'trackmgr.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/trackmgr/trackmgr_client.hpp>
#include <objects/trackmgr/TMgr_BlastRIDReply.hpp>
#include <objects/trackmgr/TMgr_CreateTracksetReply.hpp>
#include <objects/trackmgr/TMgr_CreateUserTrackReply.hpp>
#include <objects/trackmgr/TMgr_DisplayTrackReply.hpp>
#include <objects/trackmgr/TMgr_ItemResolverReply.hpp>
#include <objects/trackmgr/TMgr_RemoveUserTrackReply.hpp>
#include <objects/trackmgr/TMgr_RenameMyNCBICollectio.hpp>
#include <objects/trackmgr/TMgr_RetrieveTracksetReply.hpp>
#include <objects/trackmgr/TMgr_SupportedAssembliesRe.hpp>
#include <objects/trackmgr/TMgr_SwitchTrackContextRep.hpp>
#include <objects/trackmgr/TMgr_TrackAttrValueReply.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CTrackMgrClient_Base::Ask(const CTrackMgrClient_Base::TRequest& request, CTrackMgrClient_Base::TReply& reply, CTrackMgrClient_Base::TReplyChoice::E_Choice wanted)
{
    Ask(request, reply);
    TReplyChoice& rc = x_Choice(reply);
    if (rc.Which() == wanted) {
        return; // ok
    } else {
        rc.ThrowInvalidSelection(wanted);
    }
}

CRef<CTMgr_DisplayTrackReply> CTrackMgrClient_Base::AskDisplay_tracks(const CTMgr_DisplayTrackRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetDisplay_tracks(const_cast<CTMgr_DisplayTrackRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Display_tracks);
    return CRef<CTMgr_DisplayTrackReply>(&x_Choice(*reply).SetDisplay_tracks());
}

CRef<CTMgr_SwitchTrackContextReply> CTrackMgrClient_Base::AskSwitch_display_tracks(const CTMgr_SwitchTrackContextRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetSwitch_display_tracks(const_cast<CTMgr_SwitchTrackContextRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Switch_display_tracks);
    return CRef<CTMgr_SwitchTrackContextReply>(&x_Choice(*reply).SetSwitch_display_tracks());
}

CRef<CTMgr_TrackAttrValueReply> CTrackMgrClient_Base::AskTrack_attr_values(const CTMgr_TrackAttrValueRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetTrack_attr_values(const_cast<CTMgr_TrackAttrValueRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Track_attr_values);
    return CRef<CTMgr_TrackAttrValueReply>(&x_Choice(*reply).SetTrack_attr_values());
}

CRef<CTMgr_BlastRIDReply> CTrackMgrClient_Base::AskBlast_tracks(const CTMgr_BlastRIDRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetBlast_tracks(const_cast<CTMgr_BlastRIDRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Blast_tracks);
    return CRef<CTMgr_BlastRIDReply>(&x_Choice(*reply).SetBlast_tracks());
}

CRef<CTMgr_CreateUserTrackReply> CTrackMgrClient_Base::AskCreate_user_tracks(const CTMgr_CreateUserTrackRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetCreate_user_tracks(const_cast<CTMgr_CreateUserTrackRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Create_user_tracks);
    return CRef<CTMgr_CreateUserTrackReply>(&x_Choice(*reply).SetCreate_user_tracks());
}

CRef<CTMgr_ItemResolverReply> CTrackMgrClient_Base::AskResolve_track_items(const CTMgr_ItemResolverRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetResolve_track_items(const_cast<CTMgr_ItemResolverRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Resolve_track_items);
    return CRef<CTMgr_ItemResolverReply>(&x_Choice(*reply).SetResolve_track_items());
}

CRef<CTMgr_RemoveUserTrackReply> CTrackMgrClient_Base::AskRemove_user_tracks(const CTMgr_RemoveUserTrackRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetRemove_user_tracks(const_cast<CTMgr_RemoveUserTrackRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Remove_user_tracks);
    return CRef<CTMgr_RemoveUserTrackReply>(&x_Choice(*reply).SetRemove_user_tracks());
}

CRef<CTMgr_RetrieveTracksetReply> CTrackMgrClient_Base::AskRetrieve_tracksets(const CTMgr_RetrieveTracksetRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetRetrieve_tracksets(const_cast<CTMgr_RetrieveTracksetRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Retrieve_tracksets);
    return CRef<CTMgr_RetrieveTracksetReply>(&x_Choice(*reply).SetRetrieve_tracksets());
}

CRef<CTMgr_CreateTracksetReply> CTrackMgrClient_Base::AskCreate_trackset(const CTMgr_CreateTracksetRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetCreate_trackset(const_cast<CTMgr_CreateTracksetRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Create_trackset);
    return CRef<CTMgr_CreateTracksetReply>(&x_Choice(*reply).SetCreate_trackset());
}

CRef<CTMgr_RenameMyNCBICollectionReply> CTrackMgrClient_Base::AskRename_trackset(const CTMgr_RenameMyNCBICollectionRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetRename_trackset(const_cast<CTMgr_RenameMyNCBICollectionRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Rename_trackset);
    return CRef<CTMgr_RenameMyNCBICollectionReply>(&x_Choice(*reply).SetRename_trackset());
}

CRef<CTMgr_SupportedAssembliesReply> CTrackMgrClient_Base::AskSupported_assemblies(const CTMgr_SupportedAssembliesRequest& req, CTrackMgrClient_Base::TReply* reply)
{
    TRequestChoice request;
    TReply         reply0;
    request.SetSupported_assemblies(const_cast<CTMgr_SupportedAssembliesRequest&>(req));
    if ( !reply ) {
        reply = &reply0;
    }
    Ask(request, *reply, TReplyChoice::e_Supported_assemblies);
    return CRef<CTMgr_SupportedAssembliesReply>(&x_Choice(*reply).SetSupported_assemblies());
}

// constructor
CTrackMgrClient_Base::CTrackMgrClient_Base(void)
    : Tparent(kEmptyStr)
{
}

// destructor
CTrackMgrClient_Base::~CTrackMgrClient_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

